Attribute VB_Name = "modMidiFunctions"
' Beispiel zum Senden und Empfangen von MIDI-Daten
'
' Achtung in der IDE:
' 1.) das Empfangen von Daten muss ber eine Callback Funktion
'     gemacht werden! Da solche Funktionen in der VB IDE immer etwas kritisch
'     sind kann es durchaus passieren dass es, zb beim Beenden ber den Stopp Butten der
'     IDE oder beim Einzelschrittmodus, zu Abstrzen kommt.
' 2.) wird das Programm Fenster nicht mit dem Schliesymbol geschlossen, sondern
'     ber die Stopp-Taste der IDE, werden die geffneten Devices nicht mehr geschlossen!
'     Bei einem neuerlichen Start des Programmes kommt dann die Meldung das das Gert
'     gerade verwendet wird. Da die Handles natrlich auch nicht mehr da sind, kann
'     man die Gerte nur noch mit einem Beenden von VB freikriegen.
'
'   In anderen Beispielen zu diesem Thema wird sowohl der fr System Exculisive Messages
'   notwendige MidiHeader als auch der MidiBuffer selbst mit GlobalAlloc im Speicher
'   angelegt und anschliessend mit GlobalLock vor einem mglichen verschieben geschtzt.
'   Mglicherweise muss das auch hier noch gemacht werden (oder ist das seit dem Virtual
'   Memory Manager eh hinfllig ??) Da es bei mir keine Probleme gab, und das hier ja nur
'   ein Beispiel sein soll, hab ich mir das gespart.
'
'   Bei einer kommerziellen Verwendung ist es auf jeden Fall ratsam diese Dinge zu bedenken.
'   Ich bernehme fr etwaige Schden definitiv keine Haftung!
'
' Als Beispiele zur Entwicklung dieses Codes dienten folgende Sources:
' Following Sources where used as Samples for developing this code:
'
' Midi-Tne erzeugen by K. Langbein Klaus@ActiveVB.de
' Dumpster by David Churcher dchurcher@cix.compulink
' C++ Sample by Zane Thomas and Mabry Software, Inc.
' Thank you guys !
'
' Author: Daniel Aue Nov.2003


Option Explicit

Const CALLBACK_FUNCTION = &H30000
Const MIDI_IO_STATUS = &H20&

Const MAXERRORLENGTH = 128       '  max error text length (including NULL)

'  MIDI Input callback messages
Global Const MM_MIM_OPEN = &H3C1
Global Const MM_MIM_CLOSE = &H3C2
Global Const MM_MIM_DATA = &H3C3
Global Const MM_MIM_LONGDATA = &H3C4
Global Const MM_MIM_ERROR = &H3C5
Global Const MM_MIM_LONGERROR = &H3C6

'  device ID for MIDI mapper
Const MIDIMAPPER = (-1)

Declare Function midiInGetNumDevs Lib "winmm.dll" () As Long
Declare Function midiInGetDevCaps Lib "winmm.dll" Alias "midiInGetDevCapsA" (ByVal uDeviceID As Long, lpCaps As MIDIINCAPS, ByVal uSize As Long) As Long
Declare Function midiInOpen Lib "winmm.dll" (lphMidiIn As Long, ByVal uDeviceID As Long, ByVal dwCallback As Long, ByVal dwInstance As Long, ByVal dwFlags As Long) As Long
Declare Function midiInClose Lib "winmm.dll" (ByVal hMidiIn As Long) As Long
Declare Function midiInStart Lib "winmm.dll" (ByVal hMidiIn As Long) As Long
Declare Function midiInStop Lib "winmm.dll" (ByVal hMidiIn As Long) As Long
Declare Function midiInGetErrorText Lib "winmm.dll" Alias "midiInGetErrorTextA" (ByVal err As Long, ByVal lpText As String, ByVal uSize As Long) As Long
Declare Function midiInPrepareHeader Lib "winmm.dll" (ByVal hMidiIn As Long, lpMidiInHdr As MidiHDR, ByVal uSize As Long) As Long
Declare Function midiInAddBuffer Lib "winmm.dll" (ByVal hMidiIn As Long, lpMidiInHdr As MidiHDR, ByVal uSize As Long) As Long
Declare Function midiInUnprepareHeader Lib "winmm.dll" (ByVal hMidiIn As Long, lpMidiInHdr As MidiHDR, ByVal uSize As Long) As Long
Declare Function midiInReset Lib "winmm.dll" (ByVal hMidiIn As Long) As Long

Declare Function midiOutGetNumDevs Lib "winmm" () As Integer
Declare Function midiOutGetDevCaps Lib "winmm.dll" Alias "midiOutGetDevCapsA" (ByVal uDeviceID As Long, lpCaps As MIDIOUTCAPS, ByVal uSize As Long) As Long
Declare Function midiOutOpen Lib "winmm.dll" (lphMidiOut As Long, ByVal uDeviceID As Long, ByVal dwCallback As Long, ByVal dwInstance As Long, ByVal dwFlags As Long) As Long
Declare Function midiOutClose Lib "winmm.dll" (ByVal hMidiOut As Long) As Long
Declare Function midiOutGetErrorText Lib "winmm.dll" Alias "midiOutGetErrorTextA" (ByVal err As Long, ByVal lpText As String, ByVal uSize As Long) As Long
Declare Function midiOutPrepareHeader Lib "winmm.dll" (ByVal hMidiOut As Long, lpMidiOutHdr As MidiHDR, ByVal uSize As Long) As Long
Declare Function midiOutShortMsg Lib "winmm.dll" (ByVal hMidiOut As Long, ByVal dwMsg As Long) As Long
Declare Function midiOutLongMsg Lib "winmm.dll" (ByVal hMidiOut As Long, lpMidiOutHdr As MidiHDR, ByVal uSize As Long) As Long
Declare Function midiOutUnprepareHeader Lib "winmm.dll" (ByVal hMidiOut As Long, lpMidiOutHdr As MidiHDR, ByVal uSize As Long) As Long

' MIDI device capabilities structure's
Type MIDIOUTCAPS
    wMid As Integer                ' Manufacturer ID
    wPid As Integer                ' Product ID
    vDriverVersion As Long         ' Driver version
    szPname As String * 32         ' Product name (NULL terminated string)
    wTechnology As Integer         ' Device type
    wVoices As Integer             ' n. of voices (internal synth only)
    wNotes As Integer              ' max n. of notes (internal synth only)
    wChannelMask As Integer        ' n. of Midi channels (internal synth only)
    dwSupport As Long              ' Supported extra controllers (volume, etc)
End Type

Type MIDIINCAPS
    wMid As Integer                ' Manufacturer ID
    wPid As Integer                ' Product ID
    vDriverVersion As Long         ' Driver version
    szPname As String * 32         ' Product name (NULL terminated string)
    dwSupport As Long              ' Supported extra controllers (volume, etc)
End Type

'Hereinkommende Midi Daten knnen nicht in der Callback Funktion
'verarbeitet werden, daher wird hier ein Message Zwischenbuffer angelegt.
'Die erforderliche Grsse berechnet sich wie folgt: Midi arbeitet mit 31250 Baud,
'pro Sekunde werden also 3125 Bytes (inklusive Start+Stop Bit) bertragen.
'Eine Midi Msg hat mindestens 2 Bytes, d.h. pro ms treffen maximal 1.56 Messages ein
'Wenn die Verarbeitende Funktion alle 10ms aufgerufen wird knnen sich in diesem Zeitraum also
'maximal 15 Messages angesammelt haben. Zur Sicherheit nehmen wir das ganze noch mal 2 und
'kommen auf:
Global Const MSG_BUFFER_SIZE = 30
Public MidiInMsgBuffer() As Long  'Zwischenbuffer, wird in OpenMidiInDevice dimensioniert
Public MsgBufferInPointer As Integer   'Zeiger wohin neue Daten von der Callback Funktion hingelegt werden sollen
Public MsgBufferOutPointer As Integer  'Zeiger welche Daten von der verarbeitenden Funktion als nchstes abgeholt werden sollen


'*****************************************************************************
'Headerdefinition und Variablen fr Midi Buffer (wird nur fr System Exclusive
'Messages verwendet)
Global Const LENMIDIHDR = 64     'Byte Lnge der MidiHDR Struktur

Type MidiHDR
    lpData As Long               '  Zeiger auf den Bufferspeicher
    dwBufferLength As Long       '  Lnge des Bufferspeichers
    dwBytesRecorded As Long      '  Anzahl der vom Device aufgezeichneten Bytes (nur fr Input)
    dwUser As Long               '  for client's use
    dwFlags As Long              '  assorted flags
    lpNext As Long               '  reserved for driver
    reserved As Long             '  reserved for driver
    dwOffset As Long             '  reserved for driver
    dwReserved(8) As Long        '  8 x Long reserved for driver
End Type

'Jeder Bufferspeicher hat eine Grsse von IN_BUFFER_SIZE, insgesamt werden
'MSG_BUFFER_SIZE Buffer angemeldet. Jede hereinkommende SysExclMsg wird
'vom Device in den nchstfreien Buffer geschrieben und das MM_MIM_LONGDATA
'Event ausgelst. Sind keine Buffer mehr vorrtig werden die SysExclMsg verworfen.
'Das heisst also, dass gefllte Buffer rechtzeitig von der verarbeitenden Funktion
'abgeholt und mit midiInAddBuffer wieder angehngt werden mssen !
'die Grsse eines Buffers ist eigentlich nicht entscheident, grssere Buffer haben
'aber den Vorteil dass lngere Messages (z.B. Data Dumps) nicht so zerstckelt
'ankommen:
Const IN_BUFFER_SIZE = 100       'Grsse eines Input Buffers

Type vbMidiInBuffer             'der Typ vbMidiInBuffer dient dem leichteren Handling
    Header As MidiHDR
    Data(IN_BUFFER_SIZE) As Byte
End Type

'Die vbMidiInBuffer werden in diesem Array verwaltet:
Public MidiInBufferArray(MSG_BUFFER_SIZE) As vbMidiInBuffer     'Array fr Buffer fr hereinkommende SysExcl Daten

'Fr Midi Out brauchen wir das ganze nicht, da wir eh wissen wann wir einen
'Buffer zum verschicken von Daten brauchen.
Public MidiOutBuffer_HDR As MidiHDR         'Header fr Midi Out Buffer
Public MidiOutBuffer() As Byte              'Buffer fr abzuschickende SysExcl Daten, dynamisch dimensioniert

'Headerdefinition und Variablen fr Midi Buffer ENDE
'*****************************************************************************

Public hndMidiIn As Long    'Handle frs MidiIn Device
Public hndMidiOut As Long   'Handle frs MidiOut Device





'*****************************************************************************
'*****************************************************************************
'*****************************************************************************


Function ListMidiOutDevices(c As Control)
  'Listet alle verfgbaren Midi Out Devices auf
  ' must receive a list or combo control to take the list
  Dim i As Integer
  Dim x As Integer
  Dim MidiCaps As MIDIOUTCAPS

  c.Clear
  ' Test for MIDI mapper
  If midiOutGetDevCaps(MIDIMAPPER, MidiCaps, Len(MidiCaps)) = 0 Then ' OK
      c.AddItem MidiCaps.szPname
      c.ItemData(c.NewIndex) = MIDIMAPPER ' Save dev_id in item data
  End If
  
  ' Add other devs
  For i = 0 To midiOutGetNumDevs() - 1
    If midiOutGetDevCaps(i, MidiCaps, Len(MidiCaps)) = 0 Then ' OK
      c.AddItem MidiCaps.szPname
      c.ItemData(c.NewIndex) = i ' Save dev_id
    End If
  Next
End Function

Function ListMidiINDevices(c As Control)
  'Listet alle verfgbaren Midi In Devices auf
  ' must receive a list or combo control to take the list
  Dim i As Integer
  Dim x As Integer
  Dim MidiCaps As MIDIINCAPS

  c.Clear
  ' Test for MIDI mapper
  If midiInGetDevCaps(MIDIMAPPER, MidiCaps, Len(MidiCaps)) = 0 Then ' OK
      c.AddItem MidiCaps.szPname
      c.ItemData(c.NewIndex) = MIDIMAPPER ' Save dev_id in item data
  End If
  
  ' Add other devs
  For i = 0 To midiInGetNumDevs() - 1
    If midiInGetDevCaps(i, MidiCaps, Len(MidiCaps)) = 0 Then ' OK
      c.AddItem MidiCaps.szPname
      c.ItemData(c.NewIndex) = i ' Save dev_id
    End If
  Next
End Function


Function OpenMidiInDevice(dev_id)
  Dim nResult
  Dim s As String
  Dim x

  CloseMidiInDevice ' etwaiges vorher geffnetes Device schliessen
    
  'Device ffnen und MidiInProc als Callback Funktion fr hereinkommende Daten installieren:
  nResult = midiInOpen(hndMidiIn, dev_id, AddressOf MidiInProc, 0, CALLBACK_FUNCTION + MIDI_IO_STATUS)
    
  If Not nResult = 0 Then  'Fehler ?
    s = Space(MAXERRORLENGTH)
    midiInGetErrorText nResult, s, MAXERRORLENGTH    'Fehler Text holen
    MsgBox s, vbCritical, "Fehler:"  'und ausgeben
  Else
    
    '*** Midi in Buffer fr SysExclMsg initialisieren ***
    For x = 0 To MSG_BUFFER_SIZE
       
      MidiInBufferArray(x).Header.lpData = VarPtr(MidiInBufferArray(x).Data(0))
      MidiInBufferArray(x).Header.dwBytesRecorded = 0
      MidiInBufferArray(x).Header.dwBufferLength = IN_BUFFER_SIZE
      MidiInBufferArray(x).Header.dwUser = 0
      MidiInBufferArray(x).Header.lpNext = 0

      nResult = midiInPrepareHeader(hndMidiIn, MidiInBufferArray(x).Header, LENMIDIHDR)
      If nResult = 0 Then
        nResult = midiInAddBuffer(hndMidiIn, MidiInBufferArray(x).Header, LENMIDIHDR)
      End If
      If nResult <> 0 Then
        MsgBox "Fehler beim Anlegen der MidiIn Buffer!", vbCritical, "Fehler:"
      End If
    Next
    
    'Message Buffer dimensionieren
    ReDim MidiInMsgBuffer(MSG_BUFFER_SIZE, 3) 'MSG_BUFFER_SIZE events, je 3 daten
    MsgBufferInPointer = 0
    MsgBufferOutPointer = 0
  End If
End Function

Function CloseMidiInDevice()
  Dim nResult
  Dim s As String
  Dim x

  If hndMidiIn <> 0 Then
    midiInStop (hndMidiIn)  'auslesen der Daten stoppen
    
    nResult = midiInReset(hndMidiIn)  'device reset
    For x = 0 To MSG_BUFFER_SIZE
      nResult = midiInUnprepareHeader(hndMidiIn, MidiInBufferArray(x).Header, LENMIDIHDR)
      If nResult <> 0 Then
        MsgBox "Fehler beim Abmelden der MidiIn Buffer", vbCritical, "Fehler:"
      End If
    Next
    nResult = midiInClose(hndMidiIn) 'device schliessen
    
    If Not nResult = 0 Then  'Fehler ?
      s = Space(MAXERRORLENGTH)
      midiInGetErrorText nResult, s, MAXERRORLENGTH    'Fehler Text holen
      MsgBox s, vbCritical, "Fehler:"  'und ausgeben
    End If
    hndMidiIn = 0
  End If
End Function


Function OpenMidiOutDevice(dev_id)
  Dim nResult
  Dim s As String

  CloseMidiOutDevice ' etwaiges vorher geffnetes Device schliessen
  
  'Device ffnen:
  nResult = midiOutOpen(hndMidiOut, dev_id, 0, 0, 0)
  If Not nResult = 0 Then  'Fehler ?
    s = Space(MAXERRORLENGTH)
    midiOutGetErrorText nResult, s, MAXERRORLENGTH    'Fehler Text holen
    MsgBox s, vbCritical, "Fehler:"  'und ausgeben
  End If
End Function

Function CloseMidiOutDevice()
  Dim nResult
  Dim s As String

  If hndMidiOut <> 0 Then
    nResult = midiOutClose(hndMidiOut) 'device schliessen
    
    If Not nResult = 0 Then  'Fehler ?
      s = Space(MAXERRORLENGTH)
      midiOutGetErrorText nResult, s, MAXERRORLENGTH    'Fehler Text holen
      MsgBox s, vbCritical, "Fehler:"  'und ausgeben
    End If
    hndMidiOut = 0
  End If
End Function


Public Sub SendLongMidiMessage(DataArray)
  Dim nResult
  Dim x

  If hndMidiOut = 0 Then
    MsgBox "Es ist kein Device zur Ausgabe geffnet !", vbCritical, "Fehler:"
    Exit Sub
  End If

  ReDim MidiOutBuffer(UBound(DataArray))    'MidiOutBuffer dimensionieren
  For x = 0 To UBound(DataArray)            'und Daten reinkopieren
    MidiOutBuffer(x) = DataArray(x)         'for/next hat den Vorteil das es egal ist
  Next                                      'ob DataArray ein ByteArray ist oder nicht
  

  'Header initialisieren
  MidiOutBuffer_HDR.lpData = VarPtr(MidiOutBuffer(0))
  MidiOutBuffer_HDR.dwBytesRecorded = UBound(MidiOutBuffer) + 1
  MidiOutBuffer_HDR.dwBufferLength = UBound(MidiOutBuffer) + 1
  MidiOutBuffer_HDR.dwUser = 0
  MidiOutBuffer_HDR.lpNext = 0

  'Prepare und senden
  nResult = midiOutPrepareHeader(hndMidiOut, MidiOutBuffer_HDR, LENMIDIHDR)
  nResult = midiOutLongMsg(hndMidiOut, MidiOutBuffer_HDR, LENMIDIHDR)
  
  'Buffer wieder freigeben
  nResult = midiOutUnprepareHeader(hndMidiOut, MidiOutBuffer_HDR, LENMIDIHDR)
End Sub


Public Sub SendShortMidiMessage(DataArray)
  Dim nResult
  Dim OutData As Long
  
  If hndMidiOut = 0 Then
    MsgBox "Es ist kein Device zur Ausgabe geffnet !", vbCritical, "Fehler:"
    Exit Sub
  End If

  'Die drei Bytes in einem Long unterbringen:
  OutData = DataArray(2) * &H10000 + DataArray(1) * &H100 + DataArray(0)
  'und senden:
  nResult = midiOutShortMsg(hndMidiOut, OutData)
  If Not nResult = 0 Then
    MsgBox "Fehler bei der Datenausgabe !", vbCritical, "Fehler:"
    'Mehr Info knnte man mit midiOutGetErrorText bekommen
  End If


End Sub


Public Sub MidiInProc(ByVal hmIN As Long, ByVal wMsg As Long, ByVal dwInstance As Long, ByVal dwParam1 As Long, ByVal dwParam2 As Long)
  'ist die Callback Prozedur die aufgerufen wird wenn Midi Daten hereinkommen
  'dwParam1 sind, bei Short Messages die eigentlichen 3 Bytes der Message (von hinten nach vorn),
  'dwParam2 ist der Timestamp wann das Ereignis aufgetreten ist
  
'   O-Ton MSDN:
'     Applications should not call any system-defined functions from inside a callback
'     function, except for EnterCriticalSection, LeaveCriticalSection, midiOutLongMsg,
'     midiOutShortMsg, OutputDebugString, PostMessage, PostThreadMessage, SetEvent,
'     timeGetSystemTime, timeGetTime, timeKillEvent, and timeSetEvent.
'   Deshalb beschrnke ich mich hier aufs bergeben der Parameter.
'   Achtung: In der IDE gibts mit anderen Funktionen keine Probleme (bedenke: viele
'   VB-Befehle werden ber Systemfunktionen abgewickelt !!), wird aber eine .exe erzeugt, dann
'   kanns passieren dass der Code in der Callback Funktion zu einem Absturz fhrt !
  Dim x
  Dim nResult
  
  Select Case wMsg
    '********************************************************************
    Case MM_MIM_OPEN    'Device geffnet Message
    '********************************************************************
    Case MM_MIM_CLOSE   'Device geschlossen Message
    
    '********************************************************************
    Case MM_MIM_DATA    'normale Midi Daten sind gekommen
      If dwParam1 <> &HF8 Then  'was anderes als Midi clock ?
        MidiInMsgBuffer(MsgBufferInPointer, 0) = wMsg
        MidiInMsgBuffer(MsgBufferInPointer, 1) = dwParam1 'Daten
        MidiInMsgBuffer(MsgBufferInPointer, 2) = dwParam2 'Timestamp
        
        MsgBufferInPointer = MsgBufferInPointer + 1
        If MsgBufferInPointer = MSG_BUFFER_SIZE Then 'oben angekommen ?
          MsgBufferInPointer = 0  'rollback
        End If
      End If
    
    '********************************************************************
    Case MM_MIM_LONGDATA    'Lange Midi Daten sind angekommen.
        MidiInMsgBuffer(MsgBufferInPointer, 0) = wMsg
        MidiInMsgBuffer(MsgBufferInPointer, 1) = dwParam1 'Addresse des Bufferheaders
        MidiInMsgBuffer(MsgBufferInPointer, 2) = dwParam2 'Timestamp
              
        MsgBufferInPointer = MsgBufferInPointer + 1
        If MsgBufferInPointer = MSG_BUFFER_SIZE Then 'oben angekommen ?
          MsgBufferInPointer = 0  'rollback
        End If
    '********************************************************************
    Case MM_MIM_ERROR
    '********************************************************************
    Case MM_MIM_LONGERROR
    '********************************************************************
    Case Else
  End Select
End Sub

